
/* tx1 simulator

   P. Chongstitvatana
   Department of Computer Engineering
   Chulalongkorn University

*/

#include "tx1.h"

int AC, R[16], Ir, Pc, M[MAXMEM], RetAds,F;
int runflag, savePc;
int T;					// global clock

void trap( int num ){	// special function

	switch( num ) {
	case 0:  // stop
		printf("stop, clock %d\n",T);
		runflag = 0;
		break;
	case 1: printf("%d ",AC); break;		// print
	case 2: printf("%c",AC); break;			// printc

	}
}

void run(void){		// execute one instruction
	int op, ads, d, r1;

	savePc = Pc;
	Ir = M[Pc];		// instruction fetch
	Pc++;
	ads = IRads();	// decode
	d = IRdisp();
	r1 = IRr1();
	op = IRop();
	switch( op ) {
	case NOP:  break;
	case LDA:  AC = M[ads]; break;
	case STA:  M[ads] = AC; break;
	case JMP:  Pc = ads; break;
	case JT: if( F != 0 ) Pc = ads; break;
	case JF: if( F == 0 ) Pc = ads; break;
	case CALL: RetAds = Pc; Pc = ads; break;

	case 13:
		switch( IRxop() ){
		case CLR: R[r1] = 0; break;
		case INC: R[r1]++; break;
		case DEC: R[r1]--; break;
		}
		break;

	case 14:
		switch( IRxop() ){
		case ADD:  AC += R[r1]; break;
		case SUB:  AC += R[r1]; break;
		case AND:  AC += R[r1]; break;
		case OR:   AC += R[r1]; break;
		case XOR:  AC += R[r1]; break;

		case EQ:   F = AC == R[r1]; break;
		case LT:   F = AC <  R[r1]; break;
		case LE:   F = AC <= R[r1]; break;
		case GT:   F = AC >  R[r1]; break;
		case GE:   F = AC >= R[r1]; break;

		case MVA:  AC = R[r1]; break;
		case MVR:  R[r1] = AC; break;
		case LDX:  AC = M[(R[BP] << 4) + R[r1]]; break;
		case STX:  M[(R[BP] << 4) + R[r1]] = AC; break;
		default:  error("undefine xop");
		}
		break;

	case 15:
		switch(IRxop()){
		case ADDI: AC += d; break;
		case SUBI: AC -= d; break;
		case ANDI: AC &= d; break;
		case ORI:  AC |= d; break;
		case XORI: AC ^= d; break;

		case EQI:  F = AC == d; break;
		case LTI:  F = AC <  d; break;
		case LEI:  F = AC <= d; break;
		case GTI:  F = AC >  d; break;
		case GEI:  F = AC >= d; break;

		case MVI:  AC = d; break;
		case RET:  Pc = RetAds; break;
		case NOT:  AC = ~AC; break;
		case TRAP: trap(d); break;
		default: error("undefine xop");
		}
		break;

	default:
		error("undefine op");
	}
}

void sim(void){
	T++;
	if(runflag){
		run();
//		checkinterrupt(k);
	}
}

void initcpu(void){
	int i;
	Pc = 0;
	F = 0;
	AC = 0;
	RetAds = 0;
	for(i = 0; i < 16; i++)
		R[i] = 0;
}

void showcode(void);

int main(int argc, char *argv[]){
	if( argc < 2 ) {
		printf("usage : simtx1 objfile\n");
		exit(0);
	}
	loadprogram(argv[1]);
//	showcode();
	initcpu();
	T = 0;
	runflag = 1;
	interp();
	return 0;
}

